<?php
/*======================================================================
vCharset Converter 2.0.0  
http://www.vcharset.com/

Syrian Medical Spciety
http://www.SyrianMeds.net/

By Milad
http://www.Milado.net/

Copyright 2004-2006 SyrianMeds.net, All Rights Reserved.
This file may not be redistributed in whole or significant part.
======================================================================*/

// SET PHP ENVIRONMENT
error_reporting(E_ALL & ~E_NOTICE);
@set_time_limit(0);
ignore_user_abort(1);

// DEFINE IMPORTANT CONSTANTS
define('CVS_REVISION', '$RCSfile: vcharset.php,v $ - $Revision: 2.0.0.0 $');
define('NOZIP', 1);

// PRE-CACHE TEMPLATES AND DATA
$phrasegroups = array('charset_converter');
$specialtemplates = array();

// REQUIREMENTS
require_once('./global.php');

if ($_REQUEST['do'] == 'vcharset_installed')
{
	$mysqlversion = $vbulletin->db->query_first("SELECT VERSION() AS version");
	
	if (version_compare($mysqlversion['version'], '4.1', '>='))
	{
		$vbulletin->db->query_write("UPDATE `" . TABLE_PREFIX . "setting` SET value = '1' WHERE varname = 'vcharset_mysql_41_compatible';");
	}
	else
	{
		$vbulletin->db->query_write("UPDATE `" . TABLE_PREFIX . "setting` SET value = '0' WHERE varname = 'vcharset_mysql_41_compatible';");
		$vbulletin->db->query_write("UPDATE `" . TABLE_PREFIX . "setting` SET value = 'charset:none|collation:none' WHERE varname = 'vcharset_new_database_charset';");
	}
	
	$supported_charsets_iconv = array();
	$supported_charsets_iconv = fetch_supported_charsets_iconv_array(false, true);
	$vcharset_source = strtoupper($stylevar['charset']);
	
	if (in_array($vcharset_source, $supported_charsets_iconv))
	{
		$supported_charsets_iconv = array_flip($supported_charsets_iconv);
		$vbulletin->db->query_write("UPDATE `" . TABLE_PREFIX . "setting` SET value = '" . $supported_charsets_iconv["$vcharset_source"] . "' WHERE varname = 'vcharset_source';");
	}
	
	build_options();
	unset($supported_charsets_iconv, $vcharset_source);
	header("Location: vcharset.php");
	exit;
}

// SOME CHECKS
if (!can_administer('canadminmaintain'))
{
	print_cp_no_permission();
}

if (!function_exists('iconv'))
{
	print_cp_message($vbphrase['vcharset_no_iconv']);
}

// SETUPS
$vbulletin->input->clean_array_gpc('r', array(
	'step' => TYPE_STR,
	'table' => TYPE_STR,
	'confirm_tables' => TYPE_ARRAY,
	'confirm_collation' => TYPE_ARRAY,
));

$step = $vbulletin->GPC['step'];
$table = $vbulletin->GPC['table'];
$confirm_tables = $vbulletin->GPC['confirm_tables'];
$confirm_collation = $vbulletin->GPC['confirm_collation'];

$converter_steps = array();

$get_steps = $vbulletin->db->query_read("SELECT * FROM charset_step ORDER BY steporder ASC");

while($onestep = $vbulletin->db->fetch_array($get_steps))
{
	if ($vbulletin->options['vcharset_update_database_collation_only'] & !$onestep['onlycollation'])
	{
		$onestep['done'] = 1;
	}
	
	$steporder = $onestep['steporder'];
	
	$converter_steps["$steporder"] = $onestep;
	
	if (is_array($step_array) & !isset($next_step) & $onestep['done'] == 0)
	{
		$next_step = $onestep['steporder'];
	}
	
	if ($step == $onestep['phrase'] OR ($step == '' & $onestep['done'] == 0))
	{
		$step_array = $onestep;
		$step = $step_array['phrase'];
	}
}
$vbulletin->db->free_result($get_steps);
unset($onestep);

if (empty($_REQUEST['do']) & empty($_REQUEST['step']))
{
	$_REQUEST['do'] = 'introduction';
}

if ($_REQUEST['do'] == 'work' & empty($_REQUEST['step']) & !$step_array['useajax'])
{
	$_REQUEST['do'] = 'execute';
}

if ($_REQUEST['do'] == 'execute' & $step == 'vcharset_convert_database')
{
	// fake step
	$_REQUEST['do'] = 'vcharset_convert_database';
}

if (!$vbulletin->options['vcharset_mysql_41_compatible'])
{
	$vbulletin->options['vcharset_update_database_collation_only'] = false;
}

$headerinclude[] = '<script type="text/javascript" src="vcharset/vcharset_functions.js"></script>';
$headerinclude[] = '<script type="text/javascript" src="vcharset/jsprogressbarhandler/lib/prototype.js"></script>';
$headerinclude[] = '<script type="text/javascript" src="vcharset/jsprogressbarhandler/lib/jsProgressBarHandler.js"></script>';
$headerinclude[] = '<link rel="stylesheet" type="text/css" href="vcharset/jsprogressbarhandler/lib/jsProgressBarHandler.css" media="screen" />';
$headerincludes = implode("\n\t", $headerinclude);

// ###################### MAIN SCRIPT ###################

if ($_REQUEST['do'] == 'introduction')
{
	print_cp_header($vbphrase['vcharset_converter']);
	
	foreach ($converter_steps AS $key => $value)
	{
		$done = 'Done';
		if (!$vbulletin->options['vcharset_update_database_collation_only'])
		{
			$done = 'Done';
		}
		else
		{
			if (!$value['onlycollation'])
			{
				$done = 'Bypassed';
			}
		}
		
		$steps_explain .= $value['steporder'] . ') ' .  ($value['done'] ? '<s>' : '') . $vbphrase["$value[phrase]"] . ($value['done'] ? '</s> <b><i>' . $done . '!</i></b>' : '') . '<br />';
	}
	
	$options = fetch_supported_charsets_iconv_array();
	
	print_table_start();
	print_table_header($vbphrase['vcharset_converter']);
	print_description_row(construct_phrase($vbphrase['vcharset_introduction_text1'], $steps_explain));
	print_table_footer();

	print_table_start();
	print_table_header($vbphrase['advices']);
	print_description_row(construct_phrase($vbphrase['vcharset_introduction_text2']));
	print_table_footer();
	
	$options_array = array();
	foreach (explode('|', $vbulletin->options['vcharset_new_database_charset']) AS $key => $value)
	{
		$single_option = explode(':', $value);
		$options_array["$single_option[0]"] = $single_option[1];
	}
	
	print_form_header('vcharset', 'work', false, false, 'start', '90%', '_top', true, 'get');
	print_table_start();
	print_table_header($vbphrase['options']);
	if ($vbulletin->options['vcharset_update_database_collation_only'])
	{
		print_description_row(construct_phrase($vbphrase['vcharset_introduction_text4'], $options_array['charset'], $options_array['collation']));
	}
	else
	{
		print_description_row(construct_phrase($vbphrase['vcharset_introduction_text3'], $options[$vbulletin->options['vcharset_source']], $options[$vbulletin->options['vcharset_destination']], $options_array['charset'], $options_array['collation']));
	}
	print_submit_row($vbphrase['start'], '', 6);
	
	print_myfooter();
	print_cp_footer();
}

if ($_REQUEST['do'] == 'work')
{
	print_cp_header($vbphrase['vcharset_converter'], 'vcharset_execute_step(\'' . $step . '\');', $headerincludes);
	
	print_table_start();
	print_table_header($vbphrase['vcharset_converter'], 4);
	print_cells_row(array('Step', 'Progress', 'Done?', 'Use AJAX?'), true);
	foreach($converter_steps AS $steporder => $step)
	{
		$row_content = array(
			$vbphrase["$step[phrase]"],
			$step['useproggresbar'] ? '<span class="progressBar percentImage1" id="progress_' . $step['phrase'] . '">' . ($step['done'] ? '100%' : '0%') . '</span>' : '',
			$step['done'] ? '<img src="vcharset/famfamfam/page_tick.gif" alt="" id="image_' . $step['phrase'] . '" />' : '<img src="vcharset/famfamfam/page.gif" alt="" id="image_' . $step['phrase'] . '" />', 
			$step['useajax'] ? '<img src="vcharset/famfamfam/icon_accept.gif" alt="" />' : '<img src="vcharset/famfamfam/action_stop.gif" alt="" />', 
		);
		
		if ($vbulletin->options['vcharset_update_database_collation_only'] & !$step['onlycollation'])
		{
		
		}
		else
		{
			print_cells_row($row_content);
		}
	}
	print_table_footer();
	
	print_myfooter();
	print_cp_footer();
}

if ($_REQUEST['do'] == 'execute')
{
	if (!$step_array['useajax'])
	{
		print_cp_header($vbphrase['vcharset_converter'], '', $headerincludes);
	}
	
	$step_done = false;
	
	if(!$step_array['timestarted'])
	{
		$vbulletin->db->query_write("UPDATE charset_step SET timestarted = " . TIMENOW . " WHERE phrase = '" . $step_array['phrase'] . "'");
	}
	
	require_once(DIR . '/' . $vbulletin->config['Misc']['admincpdir'] . '/vcharset/vcharset_steps.php');
	
	if ($step_done)
	{
		mark_step_done($step_array['phrase']);
	}
	
	if ($step_array['useajax'] & $step_done)
	{
		echo "fetch_object('image_" . $step_array['phrase'] . "').src = 'vcharset/famfamfam/page_tick.gif';\n";
		
		if ($converter_steps["$next_step"]['useajax'])
		{
			echo "vcharset_execute_step('" . $converter_steps["$next_step"]['phrase'] . "');\n";
		}
		else
		{
			echo "location.replace('vcharset.php?do=execute&step=" . $converter_steps["$next_step"]['phrase'] . "');\n";
		}
	}
	elseif (!$step_array['useajax'] & $step_done)
	{
		if ($converter_steps["$next_step"]['useajax'])
		{
			define('CP_REDIRECT', 'vcharset.php?do=work');
		}
		else
		{
			define('CP_REDIRECT', 'vcharset.php?do=execute&step=' . $converter_steps["$next_step"]['phrase']);
		}
		print_stop_message($step);
	}
	
	if (!$step_array['useajax'])
	{
		print_myfooter();
		print_cp_footer();
	}
}

if ($_REQUEST['do'] == 'saveconvettable')
{
	print_cp_header($vbphrase['vcharset_converter']);
	
	if ($vbulletin->options['vcharset_mysql_41_compatible'])
	{
		// CONFIRM COLLATIONS
		$confirm_convert = array();
		$tables_to_convert_collation = 0;
		foreach ($confirm_collation AS $key => $value)
		{
			$confirm_convert[] = "'" . $key . "'";
			$tables_to_convert_collation++;
		}
		
		update_settings('vcharset_num_tables_convert_collation', $tables_to_convert_collation);
		build_options();
		
		if (count($confirm_convert) > 0)
		{
			$db->query_write("UPDATE charset_convert SET collation = 0, collation_convert = 1 WHERE item IN (" . implode(", ", $confirm_convert) . ")");
			$db->query_write("UPDATE charset_convert SET collation = 1 WHERE item NOT IN (" . implode(", ", $confirm_convert) . ")");
		}
		else if (count($confirm_convert) == 0)
		{
			$db->query_write("UPDATE charset_convert SET collation = 1");
		}
	}
	
	if (!$vbulletin->options['vcharset_update_database_collation_only'])
	{
		// CONFIRM TABLES
		$confirm_convert = array();
		$tables_to_convert = 0;
		foreach ($confirm_tables AS $key => $value)
		{
			$confirm_convert[] = "'" . $key . "'";
			$tables_to_convert++;
		}
		
		update_settings('vcharset_num_tables_convert', $tables_to_convert);
		build_options();
		
		if (count($confirm_convert) > 0)
		{
			$db->query_write("UPDATE charset_convert SET converted = 0, convertit = 1 WHERE item IN (" . implode(", ", $confirm_convert) . ")");
			$db->query_write("UPDATE charset_convert SET converted = 1 WHERE item NOT IN (" . implode(", ", $confirm_convert) . ")");
		}
		else if (count($confirm_convert) == 0)
		{
			$db->query_write("UPDATE charset_convert SET converted = 1");
		}
		
		$get_tables = $vbulletin->db->query_read("SELECT item, records FROM charset_convert WHERE convertit = 1");
		
		while ($table = $vbulletin->db->fetch_array($get_tables))
		{
			if ($table['records'] > 0)
			{
				$total_records = $total_records + $table['records'];
				$table_percent["$table[item]"] = $table['records'];
			}
		}
		
		if (count($table_percent) > 0)
		{
			foreach ($table_percent AS $table => $records)
			{
				$percent = $records / $total_records;
				$percent = round($percent, 3) * 1000;
				$db->query_write("UPDATE charset_convert SET percent = " . $percent . " WHERE item = '" . $table . "'");
			}
		}
	}
	
	mark_step_done('vcharset_tables_confirmation');
	
	if ($converter_steps["$next_step"]['useajax'])
	{
		define('CP_REDIRECT', 'vcharset.php?do=work');
	}
	else
	{
		define('CP_REDIRECT', 'vcharset.php?do=execute&step=' . $converter_steps["$next_step"]['phrase']);
	}
	print_stop_message($step);
}

if ($_REQUEST['do'] == 'vcharset_convert_database' OR $_REQUEST['do'] == 'convert')
{
	$tables = array();
	$total_percent = 0;
	$get_tables = $vbulletin->db->query_read("SELECT * FROM charset_convert WHERE convertit = 1 ORDER BY item ASC");
	while($onetable = $vbulletin->db->fetch_array($get_tables))
	{
		$tables["$onetable[item]"] = $onetable;
		
		if (is_array($table_array) & !is_array($next_table_array) &  $onetable['converted'] == 0)
		{
			$next_table_array = array();
			$next_table_array = $onetable;
		}
		
		if ($table == $onetable['item'] OR ($table == '' & $onetable['converted'] == 0))
		{
			$table_array = $onetable;
			$table = $table_array['item'];
		}
		
		if ($onetable['converted'] == 1)
		{
			$total_percent += $onetable['percent'];
		}
	}
	$vbulletin->db->free_result($get_tables);
	unset($onetable);
	
	$total_percent = $total_percent / 10;
	$total_percent = round($total_percent);
}

if ($_REQUEST['do'] == 'vcharset_convert_database')
{
	if ($table == '')
	{
		mark_step_done('vcharset_convert_database');
		if ($converter_steps["$next_step"]['useajax'])
		{
			define('CP_REDIRECT', 'vcharset.php?do=work');
		}
		else
		{
			define('CP_REDIRECT', 'vcharset.php?do=execute&step=' . $converter_steps["$next_step"]['phrase']);
		}
		print_stop_message($step);
	}
	
	print_cp_header($vbphrase['vcharset_converter'], ($table != '' ? 'vcharset_convert(\'' . $table . '\');' : ''), $headerincludes);
	
	print_table_start();
	print_table_header($vbphrase['vcharset_convert_database'] . '&nbsp;&nbsp;&nbsp;&nbsp;<span class="progressBar percentImage4" id="total_progress">' . ($total_percent ? $total_percent : '0') . '%</span>', 4);
	print_cells_row(array('Table', 'Records', 'Progress', 'Done?'), true);
	
	foreach($tables AS $item => $onetable)
	{
		$row_content = array(
			$onetable['item'],
			$onetable['records'],
			'<span class="progressBar percentImage1" id="progess_' . $onetable['item'] . '">' . ($onetable['converted'] ? '100' : '0') . '%</span>',
			($onetable['converted'] ? '<img src="vcharset/famfamfam/page_tick.gif" alt="" />' : '<img src="vcharset/famfamfam/page.gif" alt="" id="image_' . $onetable['item'] . '" />')
		);
		
		print_cells_row($row_content);
	}
	print_table_footer();
	
	print_myfooter();
	print_cp_footer();
}

if ($_REQUEST['do'] == 'convert')
{
	$primary_keys = array();
	$primary_keys = unserialize($table_array['primary_keys']);
	
	$convertable_fields = array();
	$convertable_fields = unserialize($table_array['convertable_fields']);
	
	$selectable_fields = array();
	$selectable_fields = array_merge($primary_keys, $convertable_fields);
	$selectable_fields = array_unique($selectable_fields);
	
	$full_text = array();
	$full_text = unserialize($table_array['full_text']);
	
	if (count($full_text) > 0 & $table_array['index_altered'] == 0)
	{
		remove_index($table, $full_text);
	}
	
	$get_records = $db->query_read("SELECT " . implode(", ", $selectable_fields) . " FROM " . $table . " WHERE charset_convert = 0 LIMIT " . $vbulletin->options['vcharset_records_per_cycle']);
	
	while($record = $db->fetch_array($get_records))
	{
		$sqlquery = "UPDATE " . $table . " SET ";
		
		$keys = array();
		foreach($primary_keys AS $key => $value)
		{
			$keys[] = $value . " = '" . $record["$value"] . "'";
		}
		
		$values = array();
		foreach($convertable_fields AS $key => $value)
		{
			$values[] = $value . " = '" . $db->escape_string(convert_text($record["$value"])) . "'";
		}
		
		$values[] = "charset_convert = 1";
		
		$sqlquery = $sqlquery . implode(", ", $values) . " WHERE " . implode(" AND ", $keys);
		$db->query_write($sqlquery);
	}
	
	$get_remain_records = $vbulletin->db->query_first("SELECT COUNT(*) AS num FROM " . $table . " WHERE charset_convert = 0");
	
	$remain_records = $get_remain_records['num'];
	
	if ($remain_records > 0)
	{
		$percent = round((($table_array['records'] - $remain_records) / $table_array['records']) * 100);
		echo "myJsProgressBarHandler.setPercentage('progess_" . $table . "','" . $percent . "');\n";
		echo "vcharset_convert('" . $table . "');\n";
	}
	elseif ($remain_records == 0)
	{
		mark_table_converted($table);
		if (count($full_text) > 0 & $table_array['index_altered'] == 1)
		{
			restore_index($table, $full_text);
		}
		echo "myJsProgressBarHandler.setPercentage_vcharset('progess_" . $table . "','100');\n";
		echo "fetch_object('image_" . $table . "').src = 'vcharset/famfamfam/page_tick.gif';\n";
		echo "myJsProgressBarHandler.setPercentage('total_progress', '" . $total_percent . "');\n";
		if (is_array($next_table_array))
		{
			echo "vcharset_convert('" . $next_table_array['item'] . "');\n";
		}
		else
		{
			mark_step_done('vcharset_convert_database');
			if ($converter_steps["$next_step"]['useajax'])
			{
				echo "location.replace('vcharset.php?do=work');\n";
			}
			else
			{
				echo "location.replace('vcharset.php?do=execute&step=" . $converter_steps["$next_step"]['phrase'] . "');\n";
			}
		}
	}
}

if ($_REQUEST['do'] == 'vcharset_reset')
{
	$vbulletin->db->query_write("UPDATE `charset_step` SET `done` = 0, `timestarted` = 0, `timefinished` = 0");
	define('CP_REDIRECT', 'vcharset.php');
	print_stop_message('vcharset_reset');
}

?>