<?php
/*======================================================================
vCharset Converter 2.0.0  
http://www.vcharset.com/

Syrian Medical Spciety
http://www.SyrianMeds.net/

By Milad
http://www.Milado.net/

Copyright 2004-2006 SyrianMeds.net, All Rights Reserved.
This file may not be redistributed in whole or significant part.
======================================================================*/

function update_settings($varname, $value)
{
	global $vbulletin;
	$vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "setting SET value = '" . $value . "' WHERE varname = '" . $varname . "'");
}

function convert_text($text)
{
	if (is_array($text))
	{
		foreach($text AS $key => $value)
		{
			$text[$key] = convert_text($value);
		}
		return $text;
	}
	else if ($unserialize = unserialize($text))
	{
		foreach($unserialize AS $key => $value)
		{
			$unserialize[$key] = convert_text($value);
		}
		$serialize = serialize($unserialize);
		return $serialize;
	}
	else
	{
		return iconv_convert($text);
	}
}

function iconv_convert($item)
{
	if (is_null($item))
	{
		return NULL;
	}
	else if (is_numeric($item))
	{
		return $item;
	}
	else if ($item == '')
	{
		return '';
	}
	else
	{
		global $vbulletin;
		return @iconv($vbulletin->options['vcharset_source'], $vbulletin->options['vcharset_destination'], $item);
	}
}

function fetch_supported_charsets_iconv_array($settings = false, $uppercase = false)
{
	$options = array(
	'ARMSCII-8' => ($settings ? 'Armenian (' : '') . 'ARMSCII-8' .($settings ? ')' : ''),
	'ASCII' => 'ASCII',
	'BIG5' => ($settings ? 'Chinese Traditional (' : '') . 'BIG5' .($settings ? ')' : ''),
	'BIG5-HKSCS' => ($settings ? 'Chinese Traditional (' : '') . 'BIG5-HKSCS' .($settings ? ')' : ''),
	'C99' => ($settings ? 'Unicode (' : '') . 'C99' .($settings ? ')' : ''),
	'CP874' => ($settings ? 'Thai (' : '') . 'windows-874' .($settings ? ')' : ''),
	'CP850' => 'CP850',
	'CP862' => 'CP862',
	'CP866' => ($settings ? 'Cyrillic / Russian (' : '') . 'CP866' .($settings ? ')' : ''),
	'CP932' => ($settings ? 'Japanese (' : '') . 'CP932' .($settings ? ')' : ''),
	'CP949' => ($settings ? 'Korean (' : '') . 'CP949' .($settings ? ')' : ''),
	'CP950' => ($settings ? 'Chinese (' : '') . 'CP950' .($settings ? ')' : ''),
	'CP1133' => ($settings ? 'Laotian (' : '') . 'CP1133' .($settings ? ')' : ''),
	'CP1250' => ($settings ? 'Central European (' : '') . 'windows-1250' .($settings ? ')' : ''),
	'CP1251' => ($settings ? 'Cyrillic (' : '') . 'windows-1251' .($settings ? ')' : ''),
	'CP1252' => ($settings ? 'Western (' : '') . 'windows-1252' .($settings ? ')' : ''),
	'CP1253' => ($settings ? 'Greek (' : '') . 'windows-1253' .($settings ? ')' : ''),
	'CP1254' => ($settings ? 'Turkish (' : '') . 'windows-1254' .($settings ? ')' : ''),
	'CP1255' => ($settings ? 'Hebrew (' : '') . 'windows-1255' .($settings ? ')' : ''),
	'CP1256' => ($settings ? 'Arabic (' : '') . 'windows-1256' .($settings ? ')' : ''),
	'CP1257' => ($settings ? 'Baltic (' : '') . 'windows-1257' .($settings ? ')' : ''),
	'CP1258' => ($settings ? 'Vietnamese (' : '') . 'windows-1258' .($settings ? ')' : ''),
	'EUC-CN' => ($settings ? 'Chinese Simplified (' : '') . 'EUC-CN' .($settings ? ')' : ''),
	'EUC-JP' => ($settings ? 'Japanese (' : '') . 'EUC-JP' .($settings ? ')' : ''),
	'EUC-KR' => ($settings ? 'Korean (' : '') . 'EUC-KR' .($settings ? ')' : ''),
	'EUC-TW' => ($settings ? 'Chinese Traditional (' : '') . 'EUC-TW' .($settings ? ')' : ''),
	'GBK' => ($settings ? 'Chinese Simplified (' : '') . 'GBK' .($settings ? ')' : ''),
	'GB18030' => ($settings ? 'Chinese Simplified (' : '') . 'GB18030' .($settings ? ')' : ''),
	'Georgian-Academy' => ($settings ? 'Georgian (' : '') . 'Georgian-Academy' .($settings ? ')' : ''),
	'Georgian-PS' => ($settings ? 'Georgian (' : '') . 'Georgian-PS' .($settings ? ')' : ''),
	'HP-ROMAN8' => ($settings ? 'Platform specifics (' : '') . 'HP-ROMAN8' .($settings ? ')' : ''),
	'HZ' => ($settings ? 'Chinese Simplified (' : '') . 'HZ' .($settings ? ')' : ''),
	'ISO-2022-CN' => ($settings ? 'Chinese Simplified (' : '') . 'ISO-2022-CN' .($settings ? ')' : ''),
	'ISO-2022-CN-EXT' => ($settings ? 'Chinese Simplified (' : '') . 'ISO-2022-CN-EXT' .($settings ? ')' : ''),
	'ISO-2022-JP' => ($settings ? 'Japanese (' : '') . 'ISO-2022-JP' .($settings ? ')' : ''),
	'ISO-2022-JP-1' => ($settings ? 'Japanese (' : '') . 'ISO-2022-JP-1' .($settings ? ')' : ''),
	'ISO-2022-JP-2' => ($settings ? 'Japanese (' : '') . 'ISO-2022-JP-2' .($settings ? ')' : ''),
	'ISO-2022-KR' => ($settings ? 'Korean (' : '') . 'ISO-2022-KR' .($settings ? ')' : ''),
	'ISO-8859-1' => ($settings ? 'Western (' : '') . 'ISO-8859-1' .($settings ? ')' : ''),
	'ISO-8859-2' => ($settings ? 'Central European (' : '') . 'ISO-8859-2' .($settings ? ')' : ''),
	'ISO-8859-3' => ($settings ? 'South European (' : '') . 'ISO-8859-3' .($settings ? ')' : ''),
	'ISO-8859-4' => ($settings ? 'Baltic (' : '') . 'ISO-8859-4' .($settings ? ')' : ''),
	'ISO-8859-5' => ($settings ? 'Cyrillic (' : '') . 'ISO-8859-5' .($settings ? ')' : ''),
	'ISO-8859-6' => ($settings ? 'Arabic (' : '') . 'ISO-8859-6' .($settings ? ')' : ''),
	'ISO-8859-7' => ($settings ? 'Greek (' : '') . 'ISO-8859-7' .($settings ? ')' : ''),
	'ISO-8859-8' => ($settings ? 'Hebrew Visual (' : '') . 'ISO-8859-8' .($settings ? ')' : ''),
	'ISO-8859-9' => ($settings ? 'Turkish (' : '') . 'ISO-8859-9' .($settings ? ')' : ''),
	'ISO-8859-10' => ($settings ? 'Nordic (' : '') . 'ISO-8859-10' .($settings ? ')' : ''),
	'ISO-8859-13' => ($settings ? 'Baltic (' : '') . 'ISO-8859-13' .($settings ? ')' : ''),
	'ISO-8859-14' => ($settings ? 'Celtic (' : '') . 'ISO-8859-14' .($settings ? ')' : ''),
	'ISO-8859-15' => ($settings ? 'Western (' : '') . 'ISO-8859-15' .($settings ? ')' : ''),
	'ISO-8859-16' => ($settings ? 'Romanian (' : '') . 'ISO-8859-16' .($settings ? ')' : ''),
	'JAVA' => ($settings ? 'Unicode (' : '') . 'JAVA' .($settings ? ')' : ''),
	'JOHAB' => ($settings ? 'Korean (' : '') . 'JOHAB' .($settings ? ')' : ''),
	'KOI8-R' => ($settings ? 'Cyrillic (' : '') . 'KOI8-R' .($settings ? ')' : ''),
	'KOI8-RU' => ($settings ? 'Cyrillic (' : '') . 'KOI8-RU' .($settings ? ')' : ''),
	'KOI8-T' => ($settings ? 'Tajik (' : '') . 'KOI8-T' .($settings ? ')' : ''),
	'KOI8-U' => ($settings ? 'Cyrillic / Ukrainian (' : '') . 'KOI8-U' .($settings ? ')' : ''),
	'MacArabic' => ($settings ? 'Arabic (' : '') . 'MacArabic' .($settings ? ')' : ''),
	'MacCentralEurope' => ($settings ? 'Central European (' : '') . 'MacCentralEurope' .($settings ? ')' : ''),
	'MacCroatian' => ($settings ? 'Croatian (' : '') . 'MacCroatian' .($settings ? ')' : ''),
	'MacCyrillic' => ($settings ? 'Cyrillic (' : '') . 'MacCyrillic' .($settings ? ')' : ''),
	'MacGreek' => ($settings ? 'Greek (' : '') . 'MacGreek' .($settings ? ')' : ''),
	'MacHebrew' => ($settings ? 'Hebrew (' : '') . 'MacHebrew' .($settings ? ')' : ''),
	'MacIceland' => ($settings ? 'Iceland (' : '') . 'MacIceland' .($settings ? ')' : ''),
	'Macintosh' => 'Macintosh',
	'MacRoman' => ($settings ? 'Roman (' : '') . 'MacRoman' .($settings ? ')' : ''),
	'MacRomania' => ($settings ? 'Romania (' : '') . 'MacRomania' .($settings ? ')' : ''),
	'MacThai' => ($settings ? 'Thai (' : '') . 'MacThai' .($settings ? ')' : ''),
	'MacTurkish' => ($settings ? 'Turkish (' : '') . 'MacTurkish' .($settings ? ')' : ''),
	'MacUkraine' => ($settings ? 'Cyrillic / Ukrainian (' : '') . 'MacUkrainian' .($settings ? ')' : ''),
	'MuleLao-1' => ($settings ? 'Laotian (' : '') . 'MuleLao-1' .($settings ? ')' : ''),
	'NEXTSTEP' => ($settings ? 'Platform specifics (' : '') . 'NEXTSTEP' .($settings ? ')' : ''),
	'SHIFT_JIS' => ($settings ? 'Japanese (' : '') . 'SHIFT_JIS' .($settings ? ')' : ''),
	'TCVN' => ($settings ? 'Vietnamese (' : '') . 'TCVN' .($settings ? ')' : ''),
	'TIS-620' => ($settings ? 'Thai (' : '') . 'TIS-620' .($settings ? ')' : ''),
	'UCS-2' => ($settings ? 'Unicode (' : '') . 'UCS-2' .($settings ? ')' : ''),
	'UCS-2BE' => ($settings ? 'Unicode (' : '') . 'UCS-2BE' .($settings ? ')' : ''),
	'UCS-2LE' => ($settings ? 'Unicode (' : '') . 'UCS-2LE' .($settings ? ')' : ''),
	'UCS-4' => ($settings ? 'Unicode (' : '') . 'UCS-4' .($settings ? ')' : ''),
	'UCS-4BE' => ($settings ? 'Unicode (' : '') . 'UCS-4BE' .($settings ? ')' : ''),
	'UCS-4LE' => ($settings ? 'Unicode (' : '') . 'UCS-4LE' .($settings ? ')' : ''),
	'UTF-7' => ($settings ? 'Unicode (' : '') . 'UTF-7' .($settings ? ')' : ''),
	'UTF-8' => ($settings ? 'Unicode (' : '') . 'UTF-8' .($settings ? ')' : ''),
	'UTF-16' => ($settings ? 'Unicode (' : '') . 'UTF-16' .($settings ? ')' : ''),
	'UTF-16BE' => ($settings ? 'Unicode (' : '') . 'UTF-16BE' .($settings ? ')' : ''),
	'UTF-16LE' => ($settings ? 'Unicode (' : '') . 'UTF-16LE' .($settings ? ')' : ''),
	'UTF-32' => ($settings ? 'Unicode (' : '') . 'UTF-32' .($settings ? ')' : ''),
	'UTF-32BE' => ($settings ? 'Unicode (' : '') . 'UTF-32BE' .($settings ? ')' : ''),
	'UTF-32LE' => ($settings ? 'Unicode (' : '') . 'UTF-32LE' .($settings ? ')' : ''),
	'VISCII' => ($settings ? 'Vietnamese (' : '') . 'VISCII' .($settings ? ')' : '')
	);
	
	asort($options, SORT_STRING);
	
	if ($uppercase)
	{
		foreach ($options AS $key => $value)
		{
			$options["$key"] = strtoupper($value);
		}
	}
	
	return $options;
}

function fetch_available_charsets_array()
{
	global $vbulletin, $vbphrase;
	if ($vbulletin->options['vcharset_mysql_41_compatible'])
	{
		$charsets = array();
		$options = array();
		
        $get_charset = $vbulletin->db->query_read("SHOW CHARACTER SET");
        
        while($charset = $vbulletin->db->fetch_array($get_charset))
        {
            $charsets[$charset['Charset']] = $charset['Description'];
        }
		
		$get_collation = $vbulletin->db->query_read("SHOW COLLATION");
		
		while($collation = $vbulletin->db->fetch_array($get_collation))
		{
			$key1 = $collation['Charset'] . (isset($charsets[$collation['Charset']]) ? ' (' . $charsets[$collation['Charset']] . ')' : '');
			$key2 = 'charset:' . $collation['Charset'] . '|collation:' . $collation['Collation'];
			$options["$key1"]["$key2"] = $collation['Collation'] . ($collation['Default'] == 'Yes' ? ' (Default)' : '') . ($collation['Compiled'] != 'Yes' ? ' (Not compiled)' : '');
		}
		
		return $options;
	}
	else
	{
		return array('charset:none|collation:none' => $vbphrase['vcharset_charsets_not_supported']);
	}
}

function print_myfooter()
{
	echo '<div style="text-align: center; direction: ltr; margin: 20px auto;">Powered by <a href="http://www.vcharset.com/" href="_blank">vCharset.com</a></div>';
}

function mark_step_done($phrase)
{
	global $vbulletin;
	$vbulletin->db->query_write("UPDATE charset_step SET done = 1, timefinished = " . TIMENOW  . " WHERE phrase = '" . $phrase . "'");
}

function mark_table_converted($table)
{
	global $vbulletin;
	$vbulletin->db->query_write("UPDATE charset_convert SET converted = 1 WHERE item = '" . $table . "'");
}

function remove_index($table, $full_text)
{
	global $vbulletin;
	foreach($full_text as $key => $columns)
	{
		$vbulletin->db->query_write("ALTER TABLE ". $table . " DROP INDEX " . $key);
	}
	$vbulletin->db->query_write("UPDATE charset_convert SET index_altered = 1 WHERE item = '" . $table . "'");
}

function restore_index($table, $full_text)
{
	global $vbulletin;
	foreach($full_text as $key => $columns)
	{
		$vbulletin->db->query_write("ALTER TABLE ". $table . " ADD FULLTEXT (" . implode(",", $columns) . ")");
	}
	$vbulletin->db->query_write("UPDATE charset_convert SET index_altered = 0 WHERE item = '" . $table . "'");
}
?>